/*  double.c
 *  This program demonstrates double buffering for
 *  flicker-free animation.  
 *
 *  Angel, Interactive Computer Graphics, 4th ed.
 *  Modified by MGR - 07/09/28
 */
#include <GL/glut.h>
#include <stdlib.h>
#include <math.h>

#define DEGREES_TO_RADIANS 3.14159/180.0

static GLfloat spin = 0.0, rate = 2.0;
GLfloat x, y;	// vertex of square
int doubleb;

void display()
{
    glClear (GL_COLOR_BUFFER_BIT);

    glBegin(GL_QUADS);	// draw square
       glVertex2f(x,y);
       glVertex2f(-y,x);
       glVertex2f(-x,-y);
       glVertex2f(y,-x);
    glEnd();
    glutSwapBuffers ();
}

void init ()
{
    glClearColor (0.0, 0.0, 0.0, 1.0);
    glColor3f (1.0, 1.0, 1.0);
    glShadeModel (GL_FLAT);
}

void mouse(int btn, int state, int x, int y)
{
     if(btn==GLUT_LEFT_BUTTON && state==GLUT_DOWN)
             rate = 2.0;	// MGR
     if(btn==GLUT_MIDDLE_BUTTON && state==GLUT_DOWN) rate = 0.0;// MGR
     if(btn==GLUT_RIGHT_BUTTON && state==GLUT_DOWN) exit(0);	// MGR
}

void myReshape(int w, int h)
{
    glViewport(0, 0, w, h);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (w <= h)
    glOrtho(-50.0, 50.0, -50.0*(GLfloat)h/(GLfloat)w,
        50.0*(GLfloat)h/(GLfloat)w, -1.0, 1.0);
    else
    glOrtho(-50.0*(GLfloat)w/(GLfloat)h,
        50.0*(GLfloat)w/(GLfloat)h, -50.0, 50.0, -1.0, 1.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

void spinDisplay()	
{
    spin +=  rate;
    if (spin > 360.0) spin = spin - 360.0;
    x= 25.0*cos(DEGREES_TO_RADIANS * spin);
    y= 25.0*sin(DEGREES_TO_RADIANS * spin);
    glutPostRedisplay();
}

/*  main loop
 *  open window with initial window size, title bar,
 *  RGBA display mode, and handle input events
 */
int main(int argc, char** argv)
{
    glutInit(&argc,argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
    doubleb=glutCreateWindow("double buffered");
    init();
    glutDisplayFunc(display);
    glutReshapeFunc(myReshape);
    glutIdleFunc(spinDisplay);
    glutMouseFunc(mouse);

    glutMainLoop();
}
